package ch.hepia.shop_online;


import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.ObjectMessage;
import javax.jms.TextMessage;


public class Client {

    public static void main(String[] args) throws JMSException {

        TransactionApi api = TransactionApi
            .withLocation(args.length == 1 ? args[0] : "localhost:61616") 
            .withMessage( (Message message) -> {
                    try {
                        if (message instanceof ObjectMessage objMessage && objMessage.getObject() instanceof Event.TransactionStatus t) {
                            if (t instanceof Event.TransactionAccepted ta) {
                                System.out.println("Transaction accepted: " + ta.transactionId());
                            } else if (t instanceof Event.TransactionRefused ta) {
                                System.out.println("Transaction refused: " + ta.transactionId() + " " + ta.reason());
                            }
                        }
                    } catch (JMSException e) {
                        e.printStackTrace();
                    }
                }
            );

        api.send( new Command.CreateTransaction(java.util.UUID.randomUUID().toString(), "jojo", 10_10) );
        api.send( new Command.CreateTransaction(java.util.UUID.randomUUID().toString(), "jojo", 100_50) );
        api.send( new Command.CreateTransaction(java.util.UUID.randomUUID().toString(), "jojo", 1000_00) );

    }
}
